Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 164745 - [67cat] deadlock in project scan
[67cat] deadlock in project scan
Status: VERIFIED FIXED
Product: serverplugins
Classification: Unclassified
Component: Infrastructure
6.x
All All
: P1 (vote)
: 6.x
Assigned To: Petr Hejl
issues@serverplugins
:
Depends on:
Blocks: 161367 162706
  Show dependency treegraph
 
Reported: 2009-05-08 02:52 UTC by nleck
Modified: 2009-05-29 16:08 UTC (History)
5 users (show)

See Also:
Issue Type: DEFECT
:


Attachments
deadlock detected (8.42 KB, text/plain)
2009-05-08 02:53 UTC, nleck
Details
second deadlock (25.12 KB, text/plain)
2009-05-08 03:01 UTC, nleck
Details
Screen shot of lockup. (80.40 KB, text/plain)
2009-05-08 06:36 UTC, nleck
Details
Screen shot of lockup. ( corrected mime type) (80.40 KB, image/png)
2009-05-08 06:37 UTC, nleck
Details

Note You need to log in before you can comment on or make changes to this bug.
Description nleck 2009-05-08 02:52:06 UTC
The IDE locked up completely during the project scan.
Comment 1 nleck 2009-05-08 02:53:15 UTC
Created attachment 81780 [details]
deadlock detected
Comment 2 nleck 2009-05-08 03:01:36 UTC
Created attachment 81785 [details]
second deadlock
Comment 3 nleck 2009-05-08 03:11:42 UTC
This deadlock happen twice if I tried to add a server ( which activated EE) while the project scan was running. 


The third time I waited for the scan to complete and then added the server and there was no deadlock. 
Comment 4 nleck 2009-05-08 06:36:29 UTC
Created attachment 81788 [details]
Screen shot of lockup.
Comment 5 nleck 2009-05-08 06:37:28 UTC
Created attachment 81789 [details]
Screen shot of lockup.  ( corrected mime type)
Comment 6 Jan Lahoda 2009-05-11 08:58:51 UTC
Does not seem to be related to scanning, but rather to ergonomics&J2EE servers.
Comment 7 nleck 2009-05-11 09:01:58 UTC
it's a deadlock between them... If I want for the scan to complete ( which takes too long) there is no issue. I did it
three times. I tried to set a tomcat server while waiting for the project scan to complete, each time the ide deadlocked. 

When I waited for the project scan to complete first the set up of the server went fine. 
Comment 8 Jan Lahoda 2009-05-11 09:22:51 UTC
Well, in the thread dump, the deadlock occurs during a feature enablement (ergonomics/fod). I would assume that if you
wait long enough for the enablement to finish, the deadlock does not occur. Seems that waiting for the scan to finish is
"long enough" for this.
Comment 9 Petr Jiricka 2009-05-26 11:15:10 UTC
Petr or Jarda, so what should be the correct fix for this?
Comment 10 Petr Hejl 2009-05-27 10:13:28 UTC
Fixed in web-main 0b2fe95a8d9c.

Jardo, can you review the fix?
Working on unit test.
Comment 11 Petr Hejl 2009-05-27 10:18:25 UTC
Martine, should this be fixed for 6.7?
Comment 12 Jaroslav Tulach 2009-05-27 11:21:28 UTC
I can confirm that the new patch acquires lock on ChildFactory.this while holding no other locks. This is sufficient 
fix of this deadlock, as it prevents #2 from http://en.wikipedia.org/wiki/Deadlock#Necessary_conditions

Comment 13 Martin Schovanek 2009-05-27 12:11:58 UTC
If it's safe please fix it for 6.7.
Comment 14 Marian Mirilovic 2009-05-27 12:20:59 UTC
I have no objection, if it's safe - rising to P2, to keep it on RC1 Fix Candidates radar.
Comment 15 Petr Hejl 2009-05-27 16:21:31 UTC
Update to not to reschedule rescheduled update - web-main cf4310af6019.
Comment 16 Petr Hejl 2009-05-27 16:34:52 UTC
Ooops, updating priority back to P2.
Comment 17 Quality Engineering 2009-05-27 18:44:21 UTC
Integrated into 'main-golden', will be available in build *200905271401* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/0b2fe95a8d9c
User: phejl@netbeans.org
Log: #164745 [67cat] deadlock in project scan
Comment 18 Quality Engineering 2009-05-28 08:43:43 UTC
Integrated into 'main-golden', will be available in build *200905280201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/cf4310af6019
User: phejl@netbeans.org
Log: #164745 [67cat] deadlock in project scan (refactored to separate method)
Comment 19 Marian Mirilovic 2009-05-28 09:13:52 UTC
phejl, pjiricka ... are we going to fix this for NB 6.7 ?
Comment 20 Martin Schovanek 2009-05-28 09:39:13 UTC
Verified in daily build by QE. Please transplant to Nb 6.7.
Comment 21 Petr Hejl 2009-05-28 12:26:35 UTC
Fixed in release clone.

c0e633d336a7
b71579c29472
Comment 22 Martin Schovanek 2009-05-29 16:08:20 UTC
Verified in release67 by QE.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo